<?php
/**
 * QIANFAN搜索
 *
 * Created by PhpStorm.
 * User: sunbing
 * Date: 2016/12/2
 * Time: 14:03
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class SearchController extends PluginController
{
    public $scriptPath;

    public function init() {

        parent::init();

        $pathAry = array(
            '.', 'source', 'plugin', 'qianfan', 'static', 'search', 'js', ''
        );
        $this->scriptPath = implode(DIRECTORY_SEPARATOR, $pathAry);
    }

    public function actionIndex() {
        global $_G;
        require_once( libfile('function/forum') );
        require_once( libfile('function/search') );


        $keyword = $_GET['keyword'] ? $_GET['keyword'] : '李';
        $page = $_GET['page'] ? intval($_GET['page']) : 1;

        // 搜索用户
        $srchuid = array_keys(C::t('common_member')->fetch_all_by_like_username($keyword, 0, 50));
        $user_num = count($srchuid);
        $usernames = C::t('common_member')->fetch_all_username_by_uid($srchuid);

        $i = 0;
        foreach( $srchuid as $uid ) {
            $i++;
            $user['id'] = $uid;
            $user['username'] = $usernames[$uid];
            $user['icon'] = discuz_uc_avatar($uid, 'middle', true);
            $users[] = $user;
            if($i>2) break;
        }

        // 帖子
        $start = ($page-1)*10;
        $limit = 10;
        $tids = $this->_searchThread($keyword);
        $data = C::t('forum_thread')->fetch_all_by_tid_fid_displayorder($tids, null, null, 'dateline', $start, $limit);
        $posts = [];
        if(!empty($data)) {
            foreach($data as $key => $val) {
                $posts[] = array(
                    'id' => $val['tid'],
                    'subject' => bat_highlight($val['subject'], $keyword),
                    'author' => $val['author'],
                    'postdate' => Tool::getInstance()->friendly($val['dateline']),
                    'fname' => '',
                );
            }
        }

        if($_GET['type']=='ajax')
        {
            echo json_encode($posts);
        }
        else
        {
            $this->render( 'index', array(
                'keyword' => $keyword,
                'user_num' => $user_num,
                'users' => $users,
                'posts' => $posts,
            ) );
        }
    }

    public function actionUser() {
        global $_G;
        require_once( libfile('function/forum') );

        $keyword = $_GET['keyword'] ? $_GET['keyword'] : '';
        // 搜索用户
        $srchuid = array_keys(C::t('common_member')->fetch_all_by_like_username($keyword, 0, 50));
        $user_num = count($srchuid);
        $usernames = C::t('common_member')->fetch_all_username_by_uid($srchuid);

        foreach( $srchuid as $uid ) {
            $user['id'] = $uid;
            $user['username'] = $usernames[$uid];
            $user['icon'] = discuz_uc_avatar($uid, 'middle', true);
            $users[] = $user;
        }

        $this->render( 'user', array(
            'keyword' => $keyword,
            'user_num' => $user_num,
            'users' => $users,
        ) );
    }

    private function _searchThread($srchtxt) {
        global $_G;
        require_once libfile('class/sphinx');

        $s = new SphinxClient();
        $s->setServer($_G['setting']['sphinxhost'], intval($_G['setting']['sphinxport']));
        $s->setMaxQueryTime(intval($_G['setting']['sphinxmaxquerytime']));
        $s->SetRankingMode($_G['setting']['sphinxrank']);
        $s->setLimits(0, intval($_G['setting']['sphinxlimit']), intval($_G['setting']['sphinxlimit']));
        $s->setGroupBy('tid', SPH_GROUPBY_ATTR);

        if($srchtxt) {
            if(preg_match("/\".*\"/", $srchtxt)) {
                $spx_matchmode = "PHRASE";
                $s->setMatchMode(SPH_MATCH_PHRASE);
            } elseif(preg_match("(AND|\+|&)", $srchtxt) && !preg_match("(OR|\|)", $srchtxt)) {
                $srchtxt = preg_replace("/( AND |&)/is", "+", $srchtxt);
                $spx_matchmode = "ALL";
                $s->setMatchMode(SPH_MATCH_ALL);
            } else {
                $srchtxt = preg_replace("/( OR |\|)/is", "+", $srchtxt);
                $spx_matchmode = 'ANY';
                $s->setMatchMode(SPH_MATCH_ANY);
            }
            $srchtxt = str_replace('*', '%', addcslashes($srchtxt, '%_'));
        }

        // $result = $s->query("'$srchtxt'", $_G['setting']['sphinxmsgindex']);    // 全文搜索
        $result = $s->query($srchtxt, $_G['setting']['sphinxsubindex']);      // 只搜标题

        $tids = array();
        if($result) {
            if(is_array($result['matches'])) {
                foreach($result['matches'] as $value) {
                    if($value['attrs']['tid']) {
                        $tids[$value['attrs']['tid']] = $value['attrs']['tid'];
                    }
                }
            }
        }
        return $tids;
    }

}