<?php
/**
 * Created by PhpStorm.
 * User: zhaofei
 * Date: 16/2/1
 * Time: 下午2:45
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class SettingController extends Controller
{

    public function actionFetchsmiles()
    {
        global $_G;

        $smileCategory = C::t('forum_imagetype')->fetch_all_by_type('smiley');

        $fetched = array(
            'face' => array()
        );

        $smileRootUrl = rtrim( $_G['setting']['siteurl'] , '/' ) . '/' . './static/image/smiley/';

        if( !empty($smileCategory) )
        {
            $smileRoot = DISCUZ_ROOT . './static/image/smiley/';

            //循环表情分类
            foreach( $smileCategory as $key => $category )
            {
                if( $category['available'] )
                {
                    $smileDir = $smileRoot . $category['directory'];
                    if( is_dir( $smileDir) )
                    {
                        $smiles = C::t('common_smiley')->fetch_all_by_typeid_type($category['typeid'], 'smiley', 0, 0);
                        if( !empty($smiles) )
                        {
                            foreach( $smiles as $k => $v )
                            {
                                $smiles[$k]['path'] = $category['directory'] . '/' . $v['url'];
                                $smiles[$k]['url'] = $smileRootUrl . $smiles[$k]['path'];
                                unset($smiles[$k]['type']);
                                unset($smiles[$k]['typeid']);
                                unset($smiles[$k]['displayorder']);

                                $fetched['face'][] = $smiles[$k];
                            }
                        }
                    }
                }
            }
        }

        Tool::getInstance()->success_json( $fetched );
    }

    /**
     * 查看API版本号
     */
    public function actionVer()
    {
        if( isset(Yii::app()->params['api_version']) )
        {
            Tool::getInstance()->success_json(array('api_version' => Yii::app()->params['api_version']));
        }
        else
        {
            Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
        }
    }

    /**
     * 根据原密码修改密码
     * tpye=0 根据uid修改
     * type=1 根据用户名密码修改
     *
     */
    public function actionChangePwd() {
        global $_G;

        $username = WebHelper::getPost('pwuser', '');
        $password = WebHelper::getPost('pwpwd', '');
        $newPwd = WebHelper::getPost('newpwd', '');
        $uid = WebHelper::getPost('uid', 0);
        $type = WebHelper::getPost('type', 0);

        $_GET['username'] = $username;
        $_GET['password'] = $password;
        $_GET['questionid'] = $_GET['answer'] = '';
        $_GET['loginfield'] = 'username';

        require_once libfile('class/member');
        loaducenter();

        // 根据uid直接修改
        if( $type == 0 && !empty($uid) && !empty($newPwd)) {
            $ucuser = uc_get_user( $uid, 1 );
            if( $ucuser ) {
                $ucresult = uc_user_edit( $ucuser[1], NULL, $newPwd, NULL, 1 );
                if( $ucresult == -8 ) {
                    Tool::getInstance()->fail_json( Code::USER_PROTECTED, Tool::getInstance()->lang('user_protected') );
                } else {
                    C::t('common_member')->update($uid, array('password' => md5(random(10))));
                    Tool::getInstance()->success_json(array());
                }
            }else {
                Tool::getInstance()->fail_json( Code::USER_NOT_EXISTS, Tool::getInstance()->lang( 'user_not_exists' ) );
            }
        }

        // 用户名是否为空
        if ( trim($_GET['username']) == '' ) {
            Tool::getInstance()->fail_json( Code::USERNAME_EMPTY, Tool::getInstance()->lang('username can not be empty') );
        }

        // 密码是否为空或者包含非法字符
        if( !$_GET['password'] || $_GET['password'] != addslashes($_GET['password']) || !$newPwd ||  $newPwd != addslashes($newPwd)) {
            Tool::getInstance()->fail_json( Code::PASSWORD_ILLEGAL, Tool::getInstance()->lang('profile password illegal') );
        }

        // 更新密码
        $ucresult = uc_user_edit(addslashes($_GET['username']), $_GET['password'], $newPwd, NULL);
        if( $ucresult == -8 ) {
            Tool::getInstance()->fail_json( Code::USER_PROTECTED, Tool::getInstance()->lang('user_protected') );
        }elseif( $ucresult == -1 ) {
            Tool::getInstance()->fail_json( Code::OLD_PASSWORD_INCORRECT, Tool::getInstance()->lang('old password incorrect') );
        }else {
            C::t('common_member')->update($_G['uid'], array('password' => md5(random(10))));
            Tool::getInstance()->success_json( array() );
        }
    }


    /**
     * 账号绑定和解绑第三方平台
     * BIND 绑定
     * UNBIND 解绑
     *
     */
    public function actionChangeThirdPlatform() {
        $uid = WebHelper::getPost('uid', 0);
        $operation = WebHelper::getPost('operation', 'BIND');
        $weibotype = WebHelper::getPost('weibotype', '');
        $openid = WebHelper::getPost('openid', '');
        $unionid = WebHelper::getPost('unionid', '');
        if( !$uid || !($operation == 'BIND' || $operation == 'UNBIND') || !$weibotype ) {
            Tool::getInstance()->fail_json( Code::UNDEFINED_ACTION, Tool::getInstance()->lang( 'undefined action' ) );
        }
        $result = DB::result_first("SELECT uid FROM %t WHERE uid=%s AND weibotype=%s LIMIT 1", array("thirdbind", $uid, $weibotype));

        if( $operation == 'UNBIND' ) {
            if( empty($result) ) {
                Tool::getInstance()->fail_json( Code::NOT_BIND_PLATFORM, Tool::getInstance()->lang('not bind platform') );
            }
            DB::delete('thirdbind', "uid='$uid' AND weibotype='$weibotype'");
            Tool::getInstance()->success_json( array() );
        }else {
            // 判断用户是否绑定了同样的第三方账号
            if( !empty($result) ) {
                Tool::getInstance()->fail_json( Code::BIND_OTHER_PLATFORM, Tool::getInstance()->lang('bind_other_platform') );
            }

            // 判断平台账号是否绑定了本地用户
            if( $weibotype == 'wechat' && !empty($unionid) ) {
                $user = DB::fetch_first("SELECT * FROM %t WHERE unionid = %s AND weibotype = %s LIMIT 1", array(
                    'thirdbind',
                    $unionid,
                    $weibotype
                ));
            }else {
                $user = DB::fetch_first("SELECT * FROM %t WHERE openid = %s AND weibotype = %s LIMIT 1", array(
                    'thirdbind',
                    $openid,
                    $weibotype
                ));
            }
            if( $weibotype == 'qq' && !$user ) {
                $user = DB::fetch_first( "SELECT * FROM %t WHERE conopenid = %s", array(
                    'common_member_connect',
                    $openid
                ) );
            }

            if( !empty($user) ) {
                Tool::getInstance()->fail_json( Code::BIND_OTHER_ACCOUNT, Tool::getInstance()->lang('bind_other_account') );
            }

            // 更新绑定信息
            $insertData = array();
            $insertData['uid'] = $uid;
            $insertData['weibotype'] = $weibotype;
            $insertData['openid'] = $openid;
            $insertData['dateline'] = time();
            if( $unionid ) {
                $insertData['unionid'] = $unionid;
            }
            $platformId = DB::insert( 'thirdbind', $insertData, true );

            if( $weibotype == 'qq' ) {
                $insertConnect['conopenid'] = $openid;
                $insertConnect['uid'] = $uid;
                if( $openid && $uid ) {
                    $platformId = DB::insert('common_member_connect', $insertConnect, false);
                }
                C::t('common_member')->update($uid, array('conisbind'=>1));
            }

            if( !$platformId ) {
                Tool::getInstance()->fail_json( Code::BIND_PLATFORM_FAIL, Tool::getInstance()->lang('bind_platform_fail') );
            }

            Tool::getInstance()->success_json(array());
        }
    }

    /**
     * 根据uids获取用户手机号，第三方绑定情况
     *
     */
    public function actionGetUserinfoByUid() {
        $uid = WebHelper::getPost('uid', 0);

        if( !$uid ) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('need_login') );
        }
        $phone = DB::result_first("SELECT phone FROM %t WHERE uid=%s LIMIT 1", array('phonebind', $uid));
        $phone = $phone ? $phone : '';

        $wechat = DB::fetch_first("SELECT * FROM %t WHERE uid=%s AND weibotype=%s LIMIT 1", array('thirdbind', $uid, 'wechat'));

        $qq = DB::fetch_first("SELECT * FROM %t WHERE uid=%s AND weibotype=%s LIMIT 1", array('thirdbind', $uid, 'qq'));

        $weibo = DB::fetch_first("SELECT * FROM %t WHERE uid=%s AND weibotype=%s LIMIT 1", array('thirdbind', $uid, 'weibo'));

        $data = array(
            'phone' => $phone,
            'wechat' => $wechat ? $wechat : array(),
            'qq' => $qq ? $qq : array(),
            'weibo' => $weibo ? $weibo : array()
        );

        Tool::getInstance()->success_json($data);
    }

    /**
     * 绑定和解绑手机号
     * 绑定更新 BIND
     * 解绑    UNBIND
     *
     */
    public function actionChangeUsermobile() {
        global $_G;

        $mobile = WebHelper::getPost('mobile', '');
        $_G['uid'] = WebHelper::getPost('uid', 0);
        $operation = WebHelper::getPost('operation', 'BIND');

        loaducenter();
        $ucuser = uc_get_user( $_G['uid'], 1 );
        // 登录判断
        if( !$_G['uid'] && empty($ucuser) ) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('need_login') );
        }
        $uid = $_G['uid'];
        if( !empty($operation) && $operation == 'UNBIND' ) {
            $phone = DB::result_first("SELECT phone FROM %t WHERE uid=%s LIMIT 1", array('phonebind', $_G['uid']));
            if( !empty($phone) ) {
                DB::delete('phonebind', DB::field('uid', $uid));
//                DB::query( "DELETE" . DB::table("phonebind") . " WHERE uid=" . $uid );
                Tool::getInstance()->success_json(array());
            }else {
                Tool::getInstance()->fail_json( Code::NOT_BIND_PHONE, Tool::getInstance()->lang( 'not bind phone' ) );
            }
        }

        // 验证手机号合法性
        if( !preg_match( '/^1[34578]{1}\d{9}$/', $mobile ) ) {
            Tool::getInstance()->fail_json( Code::ILLEGAL_MOBILE, Tool::getInstance()->lang( 'illegal_mobile' ) );
        }

        // 手机号是否绑定了账号
        if( $uid = DB::result_first("SELECT uid FROM %t WHERE phone=%s LIMIT 1", array('phonebind', $mobile)) ) {
            $username = DB::result_first("SELECT username FROM %t WHERE uid=%d LIMIT 1", array("common_member", $uid));
            $shortUserName = mb_substr( $username, 0, mb_strlen($username, Yii::app()->charset) - 1, Yii::app()->charset ) . '**';
            Tool::getInstance()->fail_json( Code::MOBILE_EXISTS, Tool::getInstance()->lang('mobile_exists', array('{username}' => $shortUserName)) );
        }

        if( DB::result_first("SELECT uid FROM %t WHERE uid=%d LIMIT 1", array("phonebind", $_G['uid'])) ) {
            DB::update( "phonebind", array("phone" => $mobile), "uid=" . $_G['uid'] );
        } else {
            DB::insert( "phonebind", array("uid" => $_G['uid'], "phone" => $mobile, "dateline" => TIMESTAMP) );
        }

        Tool::getInstance()->success_json(array());
    }

    /**
     * 根据uids, usernames, phones,unionids,来查找用户信息
     * type为查询方式参数,1:uids 2:usernames 3:phones 4:unionids
     * 最多100条，否则视为攻击
     * 返回uid username avatar phone
     *
     */
    public function actionGetUserinfoByType() {
        global $_G;
        require_once( libfile('function/forum') );

        $type =  WebHelper::getPost('type', 1);
        $uids = WebHelper::getPost('uids', '');
        $usernames = WebHelper::getPost('usernames', '');
        $phones = WebHelper::getPost('phones', '');
        $unionids = WebHelper::getPost('unionids', '');

        $result = array();

        if( $type == 1 && !empty($uids) ) {
            $uidArr = explode(',', $uids);
            if( count($uidArr) >= 100 ) {
                Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
            }

            $uidName = C::t('common_member')->fetch_all_username_by_uid($uidArr);
            $uidPhone = DB::fetch_all("SELECT * FROM %t WHERE uid in (%n)", array('phonebind', $uidArr));
            $phone = array();
            foreach($uidPhone as $k => $v) {
                $phone[$v['uid']] = $v['phone'];
            }

            foreach( $uidArr as $k => $v ) {
                $result[$k]['uid'] = $v;
                $result[$k]['username'] = $uidName[$v] ? $uidName[$v] : '';
                $result[$k]['phone'] = $phone[$v] ? $phone[$v] : '';
                $result[$k]['avatar'] = discuz_uc_avatar( $v, 'big', true );

            }

        }elseif( $type == 2 && !empty($usernames) ) {
            $usernameArr = explode(',', $usernames);
            if( count($usernameArr) >= 100 ) {
                Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
            }

            $usernameArr = C::t('common_member')->fetch_all_uid_by_username($usernameArr);
            $usernameUid = array_flip($usernameArr);

            $uidPhone = DB::fetch_all("SELECT * FROM %t WHERE uid in (%n)", array('phonebind', $usernameArr));
            $phone = array();
            foreach($uidPhone as $k => $v) {
                $phone[$v['uid']] = $v['phone'];
            }

            foreach( $usernameUid as $k => $v ) {
                $results['uid'] = $k;
                $results['username'] = $v;
                $results['phone'] = $phone[$k] ? $phone[$k] : '';
                $results['avatar'] = discuz_uc_avatar( $k, 'big', true );

                $result[] = $results;
            }
        }elseif( $type == 3 && !empty($phones) ) {
            $phoneArr = explode(',', $phones);
            if( count($phoneArr) >= 100 ) {
                Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
            }

            $phoneUid = DB::fetch_all("SELECT * FROM %t WHERE phone in (%n)", array('phonebind', $phoneArr));
            $phone = array();
            foreach($phoneUid as $k => $v) {
                $phone[$v['uid']] = $v['phone'];
            }
            $uidArr = array_flip($phone);
            $uidName = C::t('common_member')->fetch_all_username_by_uid($uidArr);

            foreach( $phone as $k => $v ) {
                $results['uid'] = $k;
                $results['username'] = $uidName[$k] ? $uidName[$k] : '';
                $results['phone'] = $v ? $v : '';
                $results['avatar'] = discuz_uc_avatar( $k, 'big', true );

                $result[] = $results;
            }

        }elseif( $type == 4 && $unionids) {
            $unionidArr = explode(',', $unionids);
            if( count($unionidArr) >= 100 ) {
                Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
            }

            $unionidUid = DB::fetch_all("SELECT * FROM %t WHERE unionid in (%n)", array('thirdbind', $unionidArr));
            $unionid = array();
            foreach($unionidUid as $k => $v) {
                $unionid[$v['uid']] = $v['unionid'];
            }
            $uidArr = array_flip($unionid);

            $uidName = C::t('common_member')->fetch_all_username_by_uid($uidArr);

            $uidPhone = DB::fetch_all("SELECT * FROM %t WHERE uid in (%n)", array('phonebind', $uidArr));
            $phone = array();
            foreach($uidPhone as $k => $v) {
                $phone[$v['uid']] = $v['phone'];
            }

            foreach( $unionid as $k => $v ) {
                $results['uid'] = $k;
                $results['username'] = $uidName[$k] ? $uidName[$k] : '';
                $results['phone'] = $phone[$k] ? $phone[$k] : '';
                $results['avatar'] = discuz_uc_avatar( $k, 'big', true );

                $result[] = $results;
            }
        }else {
            Tool::getInstance()->fail_json( Code::UNDEFINED_ACTION, Tool::getInstance()->lang( 'undefined action' ) );
        }

        Tool::getInstance()->success_json($result);
    }
}